# Requirements

Install shadow-cljs and install required packages

- [Leiningen](https://leiningen.org/)
- [node/npm](https://nodejs.org/en/download/)
- [shadow-cljs](https://github.com/thheller/shadow-cljs)

It's recommended to configure `clj-kondo` linter to your favorite IDE.

- https://github.com/clj-kondo/clj-kondo

# Standalone Usage

```sh
lein shadow compile :cli
node out/runops.js
```

# Development

Live reload of the compiled script.

```sh
# it will install all npm dependencies and compile it
lein shadow watch :cli
# execute it in another terminal window
# it will connect the node script js runtime to the repl
npm run dev
```

After this it will be possible to connect to REPL in your favorite IDE having access to `node` and `clojurescript` libraries.
To test it, you could use shadow-clj command to connect to the running repl executing the command below:

```sh
shadow-cljs cljs-repl :cli
shadow-cljs - config: /path/to/runops/cli/shadow-cljs.edn
shadow-cljs - connected to server
core=> (js/console.log "a message to js runtime console")
```

> Note that by default it loads the `core` namespace

After that you could issue commands that will be output to the node script JS runtime running on your terminal:

```sh
npm run dev

> runops@0.3.12 dev /path/to/runops/cli
> RUNOPS_ENV=development node out/runops.js

shadow-cljs - #16 ready!
a message to js runtime console
```

More Information: https://shadow-cljs.github.io/docs/UsersGuide.html#cljs-repl-anatomy

## Linting

The github actions will always performs linting with clj-kondo, to avoid bumping into problems,
make sure to run the command below:

```sh
make check
```

# Production Builds

```sh
make release
node runops.js ...
```

# Release Process

1. Update version:

`package.json` - version used by NPM

2. Run a production build
3. Publish package to NPM

> Make sure to ask an administrator to give access to NPM registry

```sh
make release
make publish
```

## Cursive

https://shadow-cljs.github.io/docs/UsersGuide.html#_cursive

## Emacs

https://shadow-cljs.github.io/docs/UsersGuide.html#cider

# More info

https://shadow-cljs.github.io/docs/UsersGuide.html
