(ns spinner
  (:require [cljs.nodejs :as node]))

(def ora (node/require "ora"))
(def spinner (ora.))
(def spinner-repl (ora. (clj->js {:discardStdin false})))

(defn start [data]
  (.start spinner)
  data)

(defn stop [data]
  (.stop spinner)
  data)

(defn start-repl
  "start an initialized ora instance with a custom message"
  [data]
  (.start spinner-repl (get data :spinner-msg))
  data)

(defn stop-repl
  "stop the loader with a custom message if provided"
  [data]
  (when (= (get data :spinner-action) :succeed)
    (.succeed spinner-repl (get data :spinner-msg)))
  (when (= (get data :spinner-action) :info)
    (.info spinner-repl (get data :spinner-msg)))
  (when (= (get data :spinner-action) :fail)
    (.fail spinner-repl (get data :spinner-msg)))
  (when (= (get data :spinner-action) nil)
    (.stop spinner-repl))
  data)